<?php
	require_once 'base.php';

	require_once $GLOBALS['babAddonPhpPath']."dp_ini.php";
	require_once $GLOBALS['babInstallPath']."addons".DIRECTORY_SEPARATOR."synchroad".DIRECTORY_SEPARATOR."sad_ini.php";
	require_once $GLOBALS['babInstallPath']."addons".DIRECTORY_SEPARATOR."synchroad".DIRECTORY_SEPARATOR."functions.php";
	
	function action_creating_report()
	{
		global $babBody;
		class action_creating_report_class 
		{
			function action_creating_report_class()
			{
				global $babBody;
				global $babDB;
				
				list($r, $ds, $etab, $domain, $suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
				if ($r === false)
				{
					$babBody->addError(bab_translate("Error ! No connexion to ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
				}
				else
				{
					$base_dn= "OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
					$nickname = $GLOBALS["BAB_SESS_NICKNAME"];
					$userid = $GLOBALS["BAB_SESS_USERID"];
					$res = $babDB->db_query("SELECT `firstname`, `lastname` FROM `bab_users` WHERE `id` = '".$babDB->db_escape_string($userid)."'");
					$temp = $babDB->db_fetch_array($res);
					$username = $temp["lastname"]." ".$temp["firstname"];
					$filter = "(CN=".$nickname.")";
					$sr = ldap_search($ds, $base_dn, $filter);
					$this->create_error = true;
					if (ldap_count_entries($ds, $sr) == 1)
					{					
						$entry = ldap_first_entry($ds, $sr);
						$dn = ldap_get_values($ds, $entry, "distinguishedName");
						$dn = $dn[0];
						$explode_dn = ldap_explode_dn($dn , 1);
						$iclass = $explode_dn[1];
						// Recherche des groupes classe_elv et classe_prof
						$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($iclass.STUDENTS_GROUP_SUFFIX)."'");
						if ($babDB->db_num_rows($res) > 0)
						{
							$temp = $babDB->db_fetch_array($res);
							$id_elv_group = $temp["id"];
							$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($iclass.TEACHERS_GROUP_SUFFIX)."'");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_prof_group = $temp["id"];
								$this->create_error = false;
								$this->create_error_message = "";
							}
						}
						if ($this->create_error)
						{
							$babBody->addError(bab_translate("You can't create a personal shared folder.", $GLOBALS["babAddonFolder"]));
							$this->create_error_message = bab_translate("You must be attached to a class in the Ovidentia structure!", $GLOBALS["babAddonFolder"]);
						}
						else
						{
							// Cration du dossier de suivi de l'lve ou de l'tudiant
							$folder = $nickname;
							$id_dgowner = 0;
							$relative_path = TRACKING."/";
							$bhide = 'N';
							$idsa = 0;
							$filenotify = "N";
							$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
							// Examen des ventuelles informations pour le suivi des dossiers personnels partags
							$res = $babDB->db_query("SELECT `id_folder`, `id_personal_group`,`id_prof_group` FROM `dp_folders` WHERE `id_user` = '".$babDB->db_escape_string($GLOBALS["BAB_SESS_USERID"])."'");
							if ($babDB->db_num_rows($res) === 0)
							{
								// Cration du groupe personnel de l'lve ou de l'tudiant
								$name= $nickname;
								$description = bab_translate("Personal group for", $GLOBALS["babAddonFolder"])." ".$username;
								$managerid = $GLOBALS["BAB_SESS_USERID"];
								$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."' AND `id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'");
								$temp = $babDB->db_fetch_array($res);						
								$parent = $temp["id"];
								$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = '".$babDB->db_escape_string($parent)."'");
								if ($babDB->db_num_rows($res) == 0)
								{
									$id_personal_group = bab_createGroup($name, $description, $managerid, $parent);
								}
								else
								{
									$temp = $babDB->db_fetch_array($res);
									$id_personal_group = $temp["id"];
								}
								bab_attachUserToGroup($GLOBALS["BAB_SESS_USERID"], $id_personal_group);
								$res = $babDB->db_query("INSERT INTO `dp_folders`(`id_user`, `id_folder`, `id_personal_group`, `id_prof_group`) VALUES ('".$babDB->db_escape_string($GLOBALS["BAB_SESS_USERID"])."' , '".$babDB->db_escape_string($id_folder)."' , '".$babDB->db_escape_string($id_personal_group)."', '".$babDB->db_escape_string($id_prof_group)."')");
								// Mise en place des droits sur le dossier personnel partag de suivi
								set_right_on_folder($id_folder, "upload", $id_personal_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "upload", $id_prof_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "download", $id_personal_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "download", $id_prof_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "update", $id_personal_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "update", $id_prof_group + BAB_ACL_GROUP_TREE);
								// set_right_on_folder($id_folder, "notify", $id_personal_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.5.0
								// set_right_on_folder($id_folder, "notify", $id_prof_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.5.0
								set_right_on_folder($id_folder, "manage", $id_personal_group + BAB_ACL_GROUP_TREE);
								set_right_on_folder($id_folder, "manage", $id_prof_group + BAB_ACL_GROUP_TREE);
								// set_right_on_folder($id_folder, "unzip", $id_personal_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.6.0
								// set_right_on_folder($id_folder, "unzip", $id_prof_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.6.0
								$babBody->addError(bab_translate("Your personal shared folder has been created.", $GLOBALS["babAddonFolder"]));
							}
						}						
					}
					else
					{
						$babBody->addError(bab_translate("You can't create a personal shared folder.", $GLOBALS["babAddonFolder"]));
						$this->create_error_message = bab_translate("You must be attached to a class in the Ovidentia structure!", $GLOBALS["babAddonFolder"]);
					}
				}
			}
		}
		$obj= new action_creating_report_class();
		$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."main.html", "creating_report"));
	}

	function display_creating_form()
	{
		global $babBody;
		
		class display_creating_form_class 
		{
			function display_creating_form_class()
			{
				global $babDB;
		
				$res = $babDB->db_query("SELECT `id` FROM `dp_folders` WHERE `id_user` = '".$GLOBALS["BAB_SESS_USERID"]."'");
				if ($babDB->db_num_rows($res) === 0)
				{
					$this->home_message = bab_translate("You will create your personal shared folder.", $GLOBALS['babAddonFolder']);
				}
				else
				{
					$this->home_message = bab_translate("You will update your personal shared folder.", $GLOBALS['babAddonFolder']);
				}
				$this->confirm_message = bab_translate("Do you want to continue?", $GLOBALS['babAddonFolder']);
				$this->yes = bab_translate("Yes", $GLOBALS['babAddonFolder']);
				$this->no = bab_translate("No", $GLOBALS['babAddonFolder']);
			}
		}
		$obj= new display_creating_form_class();
		$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."main.html", "creating_home"));
	}
	
	
	$confirm = bab_rp('confirm', '');

	switch ($confirm)
	{
		case "yes":
			$res = $babDB->db_query("SELECT `id` FROM `dp_folders` WHERE `id_user` = '".$GLOBALS["BAB_SESS_USERID"]."'");
			if ($babDB->db_num_rows($res) === 0)
			{	
				$babBody->title = bab_translate("Creation of the personal shared folder", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$babBody->title = bab_translate("Modification of the personal shared folder", $GLOBALS["babAddonFolder"]);
			}
			action_creating_report();
			break;
		case "no":
		default:
			$res = $babDB->db_query("SELECT `id` FROM `dp_folders` WHERE `id_user` = '".$GLOBALS["BAB_SESS_USERID"]."'");
			if ($babDB->db_num_rows($res) === 0)
			{	
				$babBody->title = bab_translate("Creation of the personal shared folder", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$babBody->title = bab_translate("Modification of the personal shared folder", $GLOBALS["babAddonFolder"]);
			}
			display_creating_form();
			break;
	}
?>